(function () {
  'use strict';
    angular.module('AR').controller('AdditionsController', function ($scope,$location , $state, api, localStorage, Collations, scriptTypes, $ionicPopup, $sce) {
      $scope.navTitle = 'New Additions';
      $scope.model = {};
      $scope.date = new Date();
      $scope.model.Collations = Collations;
      $scope.model.scriptTypes = scriptTypes;
      $scope.model.heighlight = 'heighlight';
      $scope.offensive = false;


      $scope.model.collation = $scope.model.Collations.filter(function (c) { return c.isDefault === true; })[0].key;
      $scope.model.selectedScriptType = $scope.model.scriptTypes.filter(function (c) { return c.isDefault === true; })[0].key;


      $scope.model.resultsAvailable = function () { return $scope.model.searchResults != null && $scope.model.searchResults.length > 0 };

      $scope.Search = function() {
          api.FetchNewAdditions($scope.model.collation).then(function(data) {
              $scope.model.searchResults = data;

              angular.forEach(data, function (item) {
                  if (item.Offensive) {
                      $scope.offensive = true;
                  }
              });

          });
      };

      $scope.Search();



      $scope.showPopup = function (enItem) {

          var isArabicScript = $scope.model.selectedScriptType == 1;

          api.PlayAudio(true, enItem.AudioFile).
               then(function (data) {
                   data.IsArabic = isArabicScript;
                   $scope.data = data;
                   // An elaborate, custom popup
                   var myPopup = $ionicPopup.show({
                       templateUrl: 'views/audio.html',
                       title: 'Play Audio',
                       //subTitle: 'Please use normal things',
                       scope: $scope,
                       buttons: [
                         {
                             text: '<b>close</b>',
                             type: 'button-calm',
                         }
                       ]
                   });
               });

      };


      $scope.addToArchive = function (enItem) {
          var user = localStorage.GetLoggedInUserInfo();
          var script = $scope.model.selectedScriptType == 1 ? enItem.ArabicScript : enItem.ArabicTransScript;
          api.GetArchieveWordData(enItem.SubentryId, enItem.EnglishDefinition, script, user.id).
             then(function (data) {

                 if (data.ArchieveFileDtos.length == 0) {

                     var alertPopup = $ionicPopup.alert({
                         title: 'Alert',
                         template: 'You have to create archive first. !'
                     });

                     return;
                 } else {
                     $scope.data = data;
                     $scope.data.selectedFileId = $scope.data.ArchieveFileDtos[0].FileId;
                     // An elaborate, custom popup
                     var myPopup = $ionicPopup.show({
                         templateUrl: 'views/addToArchive.html',
                         title: 'Add To Archive',
                         //subTitle: 'Please use normal things',
                         scope: $scope,
                         buttons: [
                             {
                                 text: '<b>Save</b>',
                                 type: 'button-calm',
                                 onTap: function () {
                                     var param = { FileId: $scope.data.selectedFileId, SubentryId: $scope.data.SubentryId };
                                     api.AddWordToArchive(param).then(function (result) {
                                         if (!result.IsSuccess) {
                                             $ionicPopup.alert({
                                                 title: 'Error !',
                                                 template: result.Message
                                             });
                                         } else {
                                             $ionicPopup.alert({
                                                 title: 'Confirmation',
                                                 template: result.Message
                                             });
                                         }
                                     });
                                 }
                             }
                             ,
                                  {

                                      text: '<b>Cancel</b>',
                                      type: 'bar-light'
                                  }
                         ]
                     });
                 }
             });
      };

      $scope.oepnRootSearchResult = function (item) {
          console.log(item);
          $location.path('/main/rootKey').search({
              'keyword': item.RootNumber,
              'languageTypeId': item.LanguageTypeId,
              'Root': item.Root,

          });
      };

  });


})();
