(function () {
    'use strict';
    angular.module('AR').controller('ArchiveController', function ($scope, $state, api, localStorage, $location, MaxArchives, $ionicPopup) {
        $scope.navTitle = 'My Archive ';
        $scope.model = {};
        $scope.model.noInternetConnection = noInternetConnection;
        $scope.model.errorMessage = '';
        $scope.model.showCreateFilePanel = false;
        $scope.model.newFileName = 'New archive';
        $scope.showResultMessage = false;


        //


        $scope.getArchiveFiles = function () {

            var currentUser = localStorage.GetLoggedInUserInfo();

            $scope.model.files = {};

            //if ($scope.model.noInternetConnection) {

            //    //Get Data from Storage

            //    var files = localStorage.GetLoggedInUserArchivedFiles(currentUser.id);

            //    $scope.model.files = files;

            //} else {

            //alert(currentUser.id);

                api.FetchArchiveFiles(currentUser.id).then(function (data) {
                    if (data.ArchieveFileDtos.length > 0) {
                        $scope.model.files = data.ArchieveFileDtos;
                        $scope.showResultMessage = false;
                    } else {
                        $scope.model.files = {};
                        $scope.showResultMessage = true;
                    }

                });
            //}
        }

        $scope.getArchiveFiles();

        $scope.model.entriesAvailable = function () { return $scope.model.files != null && $scope.model.files.length > 0 };


        $scope.deleteFile = function (item) {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Confirm Delete',
                template: 'Are you sure you want to delete this archive?'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    $scope.model.errorMessage = '';

                    //if ($scope.model.noInternetConnection) {

                    //    $scope.model.errorMessage = "there is no internet connection to complete this action";

                    //} else {
                        item.IsDeleteFromMobileApp = true;
                    api.DeleteArchiveFile(item).then(function(result) {
                        $scope.model.files = {};
                        //$scope.getArchiveFiles();
                        $scope.getArchiveFiles();
                    });
                       
                    //}
                } else {
                    return;
                }
            });
        };

        $scope.showCreateFilePanel = function () {

            if ($scope.model.files.length >= MaxArchives) {
                $scope.model.errorMessage = 'Can not add more archives, the max is ' + MaxArchives + ' archives.';
            }
            else
                $scope.model.showCreateFilePanel = true;

        }

        $scope.createFile = function () {

            var newFileName = $scope.model.newFileName;

            for (var i = 0; i < $scope.model.files.length ; i++) {
                var fil = $scope.model.files[i].FileName;
                if (newFileName == fil) {
                    $scope.model.errorMessage = 'Archive with same name already exists.';
                    return;
                }
            }

            var currentUser = localStorage.GetLoggedInUserInfo();

            var file = {
                FileName: $scope.model.newFileName,
                UserId: currentUser.id
            }

            api.createArchiveFile(file).then(function (data) {
                if (data > 0) {
                    $scope.model.showCreateFilePanel = false;
                    $scope.getArchiveFiles();
                    $scope.model.newFileName = 'New archive';

                }
                else {
                    $scope.model.errorMessage = 'error occured while creating the file please try again later';
                }

            });
        }

        $scope.getArchiveWords = function (file)
        {
            $location.path('/main/archiveWords').search({
                'fileId': file.FileId
                });
        }

        $scope.cancelCreateFile = function () {
            $scope.model.newFileName = 'New archive';
            $scope.model.showCreateFilePanel = false;

        }

        $scope.clickNewFile = function () {
            $scope.model.errorMessage = '';
            if ($("#newArchive").val() == 'New archive')
                $("#newArchive").val('');
        }
       
    });
})();
