(function () {
    'use strict';
    angular.module('AR').controller('ArchiveWordsController', function ($scope, $state, api, localStorage, $location, $sce, $ionicPopup) {
        $scope.navTitle = 'My Archive';
        $scope.model = {};
        $scope.model.noInternetConnection = false;
        $scope.model.errorMessage = '';
        $scope.model.fileId = $location.search().fileId;
        $scope.model.FileName = '';
        $scope.showResultMessage = false;




        $scope.getArchiveWords = function () {

            var currentUser = localStorage.GetLoggedInUserInfo();

            $scope.model.words = {};
            $scope.showResultMessage = false;

            api.FetchArchiveWords($scope.model.fileId).then(function (data) {
                $scope.model.FileName = data.FileName;
                if (data.ArchiveSubentryDtos.length > 0) {
                    $scope.model.words = data.ArchiveSubentryDtos;
                    $scope.showResultMessage = false;
                } else {
                    $scope.model.words = {};
                    $scope.showResultMessage = true;
                }
            });
        }

        $scope.getArchiveWords();

        $scope.model.entriesAvailable = function () { return $scope.model.words != null && $scope.model.words.length > 0 };


        $scope.deleteword = function (item) {
            var confirmPopup = $ionicPopup.confirm({
                title: 'Confirm Delete',
                template: 'Are you sure you want to delete this word?'
            });
            confirmPopup.then(function (res) {
                if (res) {

                    $scope.model.errorMessage = '';
                    var wordToDelete = { WordId: item.Id, IsDeleteFromMobileApp: true }

                    api.DeleteArchiveWord(wordToDelete).then(function (result) {

                        $scope.model.words = {};
                        //$scope.getArchiveWords();
                        $scope.getArchiveWords();

                    });

                } else {
                    return;
                }
            });
        };

        $scope.oepnRootSearchResult = function (item) {
            console.log(item);
            $location.path('/main/rootKey').search({
                'keyword': item.RootNumber,
                'languageTypeId': item.LanguageTypeId,
                'Root': item.RootKey,

            });
        };

        $scope.showPopup = function (enItem) {

            var isArabicScript = true;

            api.PlayAudio(true, enItem.AudioFile).
                 then(function (data) {
                     data.IsArabic = isArabicScript;
                     $scope.data = data;
                     // An elaborate, custom popup
                     var myPopup = $ionicPopup.show({
                         templateUrl: 'views/audio.html',
                         title: 'Play Audio',
                         //subTitle: 'Please use normal things',
                         scope: $scope,
                         buttons: [
                           {
                               text: '<b>close</b>',
                               type: 'button-calm',
                           },
                         ]
                     });
                 });
        };

    });
})();
