(function () {
    'use strict';
    angular.module('AR').controller('CategoriesController', function ($scope, $state, api, Collations, $location) {
        $scope.navTitle = 'Categories Search';
        $scope.model = {};

        $scope.model.showGeneralTopics = true;
        $scope.model.showIndex = false;
        $scope.model.showIdioms = false;

        $scope.model.Collations = Collations;
        $scope.model.Collations = Collations;
        $scope.model.collation = $scope.model.Collations.filter(function (c) { return c.isDefault === true; })[0].key;

        $scope.model.enableIdioms = $scope.model.collation == "2" ? true : false;


        $scope.model.resultsAvailable = function () { return $scope.model.searchResults != null && $scope.model.searchResults.length > 0 };

        api.FetchCategory($scope.model.collation).then(function (data) {
            $scope.model.searchResults = data;
        });

        $scope.Search = function () {

            $scope.model.enableIdioms = $scope.model.collation == "2" ? true : false;

            if ($scope.model.showGeneralTopics) {
                $scope.generalTopics();
            } else {
                $scope.index();
            }
        };



        $scope.getGeneralTopicSubEntries = function (data) {
            $scope.getSubEntries(data, 'general');
        }

        $scope.getIdiomsSubEntries = function (data) {
            $scope.getSubEntries(data, 'idioms');
        }

        $scope.getIndexSubEntries = function (data) {
            $scope.getSubEntries(data, 'index');
        }

        $scope.getSubEntries = function (data, type) {
            $location.path('/main/categoriesSearchResult').search({
                'categoryId': type == 'index' ? data.Id : data.CategoryId,
                'languageTypeId': $scope.model.collation,
                'type': type,
            });
        }

        $scope.HideShowNav = function (showGeneralTopics, showIndex, showIdioms) {
            $scope.model.showGeneralTopics = showGeneralTopics;
            $scope.model.showIndex = showIndex;
            $scope.model.showIdioms = showIdioms;
        }

        $scope.generalTopics = function () {

            $scope.HideShowNav(true, false, false);

            api.FetchCategory($scope.model.collation).then(function (data) {
                $scope.model.searchResults = data;
            });
        };

        $scope.index = function () {
            $scope.HideShowNav(false, true, false);

            api.FetchIndex(0, $scope.model.collation).then(function (data) {
                $scope.model.searchResults = data;

                angular.forEach($scope.model.searchResults, function (result, key) {
                    api.FetchIndex(result.Id, $scope.model.collation).then(function (topics) {
                        result.topics = topics;
                        //if ($scope.model.searchResults.topics.length == 0) $scope.model.searchResults = null;

                    });
                });
               
            });
        };

        $scope.idiomsAndSlang = function () {

            $scope.HideShowNav(false, false, true);

            api.FetchIdiomsAndSlang().then(function (data) {
                console.log(data.ChildCategories);
                $scope.model.searchResults = data.ChildCategories;
            });
        };


        //$scope.GetTopicsIndex = function (item) {
        //    $scope.HideShowNav(false, true, false);
        //    api.FetchIndex(item.Id, $scope.model.collation).then(function (topics) {
        //        $scope.model.searchResults.topics = topics;

        //    });
        //};
        
        /*
         Accordion actions
         */
        $scope.toggleGroup = function (group) {
            if ($scope.isGroupShown(group)) {
                $scope.shownGroup = null;
            } else {
                $scope.shownGroup = group;
            }
        };
        $scope.isGroupShown = function (group) {
            return $scope.shownGroup === group;
        };
    });
})();
