(function () {
    'use strict';
    angular.module('AR').controller('ConjugationController', function ($scope, $location, api, $stateParams) {
        $scope.navTitle = 'Verb Forms ';
        $scope.model = {};
        $scope.model.word = $stateParams.word;
        $scope.model.languageTypeId = $stateParams.languageTypeId;
        $scope.model.type = $stateParams.type;
        $scope.isTranscriptionEnabled = true;


        //alert($scope.model.word)
        //alert($scope.model.languageTypeId)
        //alert($scope.model.type)

        api.GetConjuctionForms($scope.model.word, $scope.model.languageTypeId, $scope.model.type).then(function (data) {
            $scope.model.searchResults = data.ConjugationFormsDtos;
        });

        $scope.model.resultsAvailable = function () { return $scope.model.searchResults != null && $scope.model.searchResults.length > 0; };

        $scope.ShowVerbForms = function (item) {

            $location.path('/main/conjugationVerbForms').search({
                'word': $scope.model.word,
                'languageTypeId': $scope.model.languageTypeId,
                type: $scope.model.type,
                subentryId : item.Id
            });

        };

        $scope.ShowTranscription = function () {

            if ($scope.model.languageTypeId == "2") {

                $location.path('/main/transcriptionEca');


            } else {
                $location.path('/main/transcriptionMsa');

            }
        };




    });
})();
