(function () {
    'use strict';
    angular.module('AR').controller('ConjugationVerbFormsController', function ($rootScope, $ionicSideMenuDelegate,$scope, $location, api, $ionicPopup, $sce) {
        $scope.navTitle = 'Conjugation Table';
        $scope.model = {};
        $scope.model.word = $location.search().word;
        $scope.model.languageTypeId = $location.search().languageTypeId;
        $scope.model.type = $location.search().type;
        $scope.model.subentryId = $location.search().subentryId;
        $scope.isTranscriptionEnabled = true;


        api.GetConjuctionVerbForms($scope.model.word, $scope.model.languageTypeId, $scope.model.type, $scope.model.subentryId).then(function (data) {
            //$rootScope.hasError = false;
            //$rootScope.eroor = "";
            $scope.model.searchResults = data.VerbFormTenseDtos;
            $scope.model.Form = data.Form;
            $scope.model.RootType = data.RootType;
            $scope.model.RootEnglish = data.RootEnglish;
            $scope.model.RootArabic = data.RootArabic;
            $scope.model.ArabicScript = data.ArabicScript;
            $scope.model.EnglishDefinition = data.EnglishDefinition;
            $scope.model.ArabicTranscription = data.ArabicTranscription;

            $(".backdrop").addClass("aduioScroll1");

        });


        $scope.model.resultsAvailable = function () { return $scope.model.searchResults != null && $scope.model.searchResults.length > 0; };


        $scope.showPopup = function (enItem) {

            $(".button.col.ng-binding.button-calm").trigger("click");
            $(".backdrop").addClass("aduioScroll1");


            var isArabicScript = true;
            api.PlayAudio(false, enItem.AudioFile).
                then(function(data) {
                    data.IsArabic = isArabicScript;
                    data.TenseName = enItem.TenseName;
                    $scope.data = data;

                    // An elaborate, custom popup
                    var myPopup = $ionicPopup.show({
                        templateUrl: 'views/audioWithScroll.html',
                        title: 'Play Audio',
                        //subTitle: 'Please use normal things',
                        scope: $scope,
                        buttons: [
                            {
                                text: '<b>close</b>',
                                type: 'button-calm',
                            },
                        ]
                    });


                });

        };

        $scope.ShowTranscription = function () {

            if ($scope.model.languageTypeId == "2") {

                $location.path('/main/transcriptionEca');


            } else {
                $location.path('/main/transcriptionMsa');

            }
        };

        $scope.ShowPattern = function () {

            if ($scope.model.languageTypeId == "2") {

                $location.path('/main/patternEca');


            } else {
                $location.path('/main/patternMsa');

            }
        }

        $(".bar-header").on("click", function () {

            $(".button.col.ng-binding.button-calm").trigger("click");
            $(".backdrop").removeClass("aduioScroll1");

        });
        

      
    });
})();

