(function () {
    'use strict';
    angular.module('AR').controller('EnglishSearchController', function ($scope, $state, $location, api, Collations, scriptTypes, $ionicPopup, $sce, localStorage, $stateParams) {
        $scope.navTitle = 'English Search';
        $scope.model = {};
        $scope.errorMessage = '';
        $scope.isConjugationEnabled = false;
        $scope.isTranscriptionEnabled = false;
        $scope.offensive = false;

        $scope.model.Collations = Collations;
        $scope.model.scriptTypes = scriptTypes;
        $scope.model.heighlight = 'heighlight';
        $scope.model.emptyResultMessage = '';

       
        $scope.model.collation = $scope.model.Collations.filter(function (c) { return c.isDefault === true; })[0].key;

        $scope.model.selectedScriptType =  $scope.model.scriptTypes.filter(function (c) { return c.isDefault === true; })[0].key;

        $scope.model.showEmptyResultMessage = false;

        $scope.Init = function () {

            $scope.model.showEmptyResultMessage = false;

            if (window.localStorage.getItem("isInit") != "true") {

                $scope.model.searchKeyword = window.localStorage.getItem("searchKeyword_English");
                $scope.model.collation = window.localStorage.getItem("collation_English");
                $scope.model.selectedScriptType = window.localStorage.getItem("selectedScriptType_English");
                $scope.model.isFiveLetters = window.localStorage.getItem("isFiveLetters_English");

                api.FetchEnglishSearchResult($scope.model.searchKeyword, $scope.model.isFiveLetters, $scope.model.collation).then(function(data) {
                    $scope.model.searchResults = data.SearchResultData.sort(function compare(a, b) {

                        var aname = a.Word;
                        var bname = b.Word;

                        var exist = new RegExp('[^\\d]\\d+$').test(aname);
                        var bexist = new RegExp('[^\\d]\\d+$').test(bname);

                        if (exist) {
                            var rrr = new RegExp('[^\\d]\\d+$');
                            var endStr = rrr.exec(aname).toString();
                            aname = aname.replace(endStr, ' ' + endStr[1]);
                        } 

                        if (bexist) {
                            var bbb = new RegExp('[^\\d]\\d+$');
                            var endb = bbb.exec(bname).toString();
                            bname = bname.replace(endb, ' ' + endb[1]);
                        }


                        var adashregex = new RegExp('^([a-zA-Z]*-[a-zA-Z]*)+$').test(aname);
                        var bdashregex = new RegExp('^([a-zA-Z]*-[a-zA-Z]*)+$').test(bname);

                        if (adashregex) {
                            aname = aname.replace('-', '');
                        }

                        if (bdashregex) {

                            bname = bname.replace('-', '');
                        }


                        if (aname < bname) return -1;
                        if (aname > bname) return 1;
                        return 0;
                    });

                    $scope.isConjugationEnabled = data.IsConjugationEnabled;
                    $scope.offensive = data.Offensive;

                    if ($scope.model.searchResults == null || $scope.model.searchResults.length == 0) {
                        $scope.model.showEmptyResultMessage = true;
                        $scope.isTranscriptionEnabled = false;

                    } else {
                        $scope.model.showEmptyResultMessage = false;
                        $scope.isTranscriptionEnabled = true;
                    }

                }, function() {
                    // $scope.errorMessage = 'error occurred please try again later ...';
                });

            } 
        };

        $scope.Init();

        $scope.Search = function (isFiveLetters) {

            $scope.errorMessage = '';
            $scope.model.emptyResultMessage = '';
            $scope.model.isFiveLetters = isFiveLetters;


            if ($scope.model.searchKeyword == "") {
                $scope.errorMessage = "Search Keyword is required";
            }
            else if ($scope.model.isFiveLetters == true && $scope.model.searchKeyword.length < 5) {
                $scope.errorMessage = "Please Enter At Least Five Letters";
            } else {

                window.localStorage.setItem("searchKeyword_English", $scope.model.searchKeyword);
                window.localStorage.setItem("collation_English", $scope.model.collation);
                window.localStorage.setItem("selectedScriptType_English", $scope.model.selectedScriptType);
                window.localStorage.setItem("isFiveLetters_English", $scope.model.isFiveLetters);
                window.localStorage.setItem("isInit", "false");


                api.FetchEnglishSearchResult($scope.model.searchKeyword, isFiveLetters, $scope.model.collation).then(function (data) {
                    $scope.model.searchResults = data.SearchResultData.sort(function compare(a, b) {

                        var aname = a.Word;
                        var bname = b.Word;

                        var exist = new RegExp('[^\\d]\\d+$').test(aname);
                        var bexist = new RegExp('[^\\d]\\d+$').test(bname);

                        if (exist) {
                            var rrr = new RegExp('[^\\d]\\d+$');
                            var endStr = rrr.exec(aname).toString();
                            aname = aname.replace(endStr, ' ' + endStr[1]);
                        }

                        if (bexist) {
                            var bbb = new RegExp('[^\\d]\\d+$');
                            var endb = bbb.exec(bname).toString();
                            bname = bname.replace(endb, ' ' + endb[1]);
                        }

                        var adashregex = new RegExp('^([a-zA-Z]*-[a-zA-Z]*)+$').test(aname);
                        var bdashregex = new RegExp('^([a-zA-Z]*-[a-zA-Z]*)+$').test(bname);

                        if (adashregex) {
                            aname = aname.replace('-', '');
                        }

                        if (bdashregex) {

                            bname = bname.replace('-', '');
                        }

                        if (aname < bname) return -1;
                        if (aname > bname) return 1;
                        return 0;
                    });

                    $scope.isConjugationEnabled = data.IsConjugationEnabled;
                    $scope.offensive = data.Offensive;

                    if ($scope.model.searchResults == null || $scope.model.searchResults.length == 0) {
                        $scope.model.showEmptyResultMessage = true;
                        $scope.isTranscriptionEnabled = false;

                    } else {
                        $scope.model.showEmptyResultMessage = false;
                        $scope.isTranscriptionEnabled = true;
                    }

                }, function () {
                    // $scope.errorMessage = 'error occurred please try again later ...';
                });
            }
        };

        $scope.isShaded = function (item) {
            if (item.IsShaded) {
                return 'model.heighlight';
            } else {
                return '';
            }
        };

        $scope.ShowConjugation = function () {

            $location.path('/main/conjugation/' + $scope.model.searchKeyword + '/' + $scope.model.collation + '/0');
        };

        $scope.ShowTranscription = function () {

            if ($scope.model.collation == 2) {

                $location.path('/main/transcriptionEca');


            } else {
                $location.path('/main/transcriptionMsa');

            }
        };

        $scope.oepnRootSearchResult = function (item) {

            $location.path('/main/rootKey').search({
                'keyword': item.RootNumber,
                'Root': item.Root,
                'languageTypeId': $scope.model.collation,
            });
        };

        $scope.showPopup = function (enItem) {

            var isArabicScript = $scope.model.selectedScriptType == 1;

            api.PlayAudio(true, enItem.AudioFile).
                 then(function (data) {
                     data.IsArabic = isArabicScript;
                     $scope.data = data;
                     // An elaborate, custom popup
                     var myPopup = $ionicPopup.show({
                         templateUrl: 'views/audio.html',
                         title: 'Play Audio',
                         //subTitle: 'Please use normal things',
                         scope: $scope,
                         buttons: [
                           {
                               text: '<b>close</b>',
                               type: 'button-calm',
                           },
                         ]
                     });
                 });
        };
        $scope.addToArchive = function (enItem) {

            var user = localStorage.GetLoggedInUserInfo();
            var script = $scope.model.selectedScriptType == 1 ? enItem.ArabicScript : enItem.ArabicTransScript;
            api.GetArchieveWordData(enItem.SubentryId, enItem.Definition, script, user.id).
               then(function (data) {

                   if (data.ArchieveFileDtos.length == 0) {


                       var alertPopup = $ionicPopup.alert({
                           title: 'Alert',
                           template: 'You have to create archive first. !'
                       });


                       return;
                   } else {
                       $scope.data = data;
                       $scope.data.selectedFileId = $scope.data.ArchieveFileDtos[0].FileId;
                       // An elaborate, custom popup
                       var myPopup = $ionicPopup.show({
                           templateUrl: 'views/addToArchive.html',
                           title: 'Add To Archive',
                           //subTitle: 'Please use normal things',
                           scope: $scope,
                           buttons: [
                             {
                                 text: '<b>Save</b>',
                                 type: 'button-calm',
                                 onTap: function () {
                                     var param = { FileId: $scope.data.selectedFileId, SubentryId: $scope.data.SubentryId };
                                     api.AddWordToArchive(param).then(function (result) {
                                         console.log(result);
                                         if (!result.IsSuccess) {
                                             $ionicPopup.alert({
                                                 title: 'Error !',
                                                 template: result.Message
                                             });
                                         } else {
                                             $ionicPopup.alert({
                                                 title: 'Confirmation',
                                                 template: result.Message
                                             });
                                         }
                                     });
                                 }
                             },
                               {

                                   text: '<b>Cancel</b>',
                                   type: 'bar-light'
                               }
                           ]
                       });

                   }
               });

        };

        $('#searchBox').focus();

    });

})();

