(function () {
  'use strict';
  angular.module('AR').controller('LoginController', function ($scope, $state, api, localStorage, webSiteUrl) {
      //$scope.navTitle = 'Login Page';
      $scope.model = {};
      $scope.model.errorMessage = '';

      $scope.Login = function () {
          $scope.model.errorMessage = '';

          if ($scope.model.UserName == null || $scope.model.Password == null) {
              $scope.model.errorMessage = "Log in failed please enter valid username/password";
              return;
          }

          api.Login($scope.model.UserName, $scope.model.Password).then(function(data) {
              if (data.Success) {

                  localStorage.StoreLoggedInUserInfo(data.UserId, data.UserName, data.Password, data.IsPowerAdmin);

                  window.localStorage.setItem("isInit", "true");

                  console.log(window.localStorage.getItem("isInit"));

                  if (data.IsPowerAdmin) {
                      window.showAdminUrl = true;
                  } else {
                      window.showAdminUrl = false;
                  }

                  $state.go('main.englishSearch');
              } else {
                  $scope.model.errorMessage = "Log in failed please enter valid username/password";
              }
          });
      };

      $scope.CreateNewAccount = function () {
          window.open(webSiteUrl, '_system');
      };

      $("#userName").focus(function () {
          $scope.model.errorMessage = "";
      });

      $("#password").focus(function () {
          $scope.model.errorMessage = "";
      });

  });
})();
