(function () {
    'use strict';
    angular.module('AR').controller('RootKeyController', function ($scope, $state,localStorage, $location,scriptTypes, api, $ionicPopup, $sce) {
        $scope.navTitle = 'Root Search';
        $scope.model = {};
        $scope.errorMessage = '';
        $scope.model.scriptTypes = scriptTypes;
        $scope.model.languageTypeId = $location.search().languageTypeId;
        $scope.model.keyword = $location.search().keyword;
        $scope.model.Root = $location.search().Root;
        $scope.model.heighlight = 'heighlight';
        $scope.offensive = false;
        $scope.model.showEmptyResultMessage = false;


        $scope.model.selectedScriptType = $scope.model.scriptTypes.filter(function (c) { return c.isDefault === true; })[0].key;


        $scope.Search = function () {
            $scope.model.showEmptyResultMessage = false;

            api.FetchRootKeyResult($scope.model.keyword, $scope.model.languageTypeId).then(function (data) {
                angular.forEach(data.RootKeyDtos, function (item) {
                    if (item.Offensive) {
                        $scope.offensive = true;
                    }
                });

                $scope.model.searchResults = data.RootKeyDtos;

                if ($scope.model.searchResults == null || $scope.model.searchResults.length == 0) {
                    $scope.model.showEmptyResultMessage = true;

                } else {
                    $scope.model.showEmptyResultMessage = false;
                }
            });
        };

        $scope.Search();

        $scope.model.resultsAvailable = function () { return $scope.model.searchResults != null && $scope.model.searchResults.length > 0; };

        $scope.showPopup = function (enItem) {

            var isArabicScript = $scope.model.selectedScriptType == 1;

            api.PlayAudio(true, enItem.AudioFile).
                 then(function (data) {
                     data.IsArabic = isArabicScript;
                     $scope.data = data;
                     // An elaborate, custom popup
                     var myPopup = $ionicPopup.show({
                         templateUrl: 'views/audio.html',
                         title: 'Play Audio',
                         //subTitle: 'Please use normal things',
                         scope: $scope,
                         buttons: [
                           {
                               text: '<b>close</b>',
                               type: 'button-calm',
                           },
                         ]
                     });
                 });
        };

        $scope.addToArchive = function (enItem) {
            var user = localStorage.GetLoggedInUserInfo();
            var script = $scope.model.selectedScriptType == 1 ? enItem.ArabicScript : enItem.ArabicTransScript;
            api.GetArchieveWordData(enItem.Id, enItem.Definition, script, user.id).
               then(function (data) {

                   if (data.ArchieveFileDtos.length == 0) {


                       var alertPopup = $ionicPopup.alert({
                           title: 'Alert',
                           template: 'You have to create archive first. !'
                       });


                       return;
                   } else {
                       $scope.data = data;
                       $scope.data.selectedFileId = $scope.data.ArchieveFileDtos[0].FileId;
                       // An elaborate, custom popup
                       var myPopup = $ionicPopup.show({
                           templateUrl: 'views/addToArchive.html',
                           title: 'Add To Archive',
                           //subTitle: 'Please use normal things',
                           scope: $scope,
                           buttons: [
                             {
                                 text: '<b>Save</b>',
                                 type: 'button-calm',
                                 onTap: function () {
                                     var param = { FileId: $scope.data.selectedFileId, SubentryId: $scope.data.SubentryId };
                                     api.AddWordToArchive(param).then(function (result) {
                                         console.log(result);
                                         if (!result.IsSuccess) {
                                             $ionicPopup.alert({
                                                 title: 'Error !',
                                                 template: result.Message
                                             });
                                         } else {
                                             $ionicPopup.alert({
                                                 title: 'Confirmation',
                                                 template: result.Message
                                             });
                                         }
                                     });
                                 }
                             },
                               {

                                   text: '<b>Cancel</b>',
                                   type: 'bar-light'
                               }
                           ]
                       });

                   }
               });

        };
    });
})();
