(function () {
    'use strict';
    var ar = angular.module('AR');
    ar.factory('api', function (request, clientDetails) {
        return {

            Login: function (userName, password) {
                var requestBod = 'Login?userName=' + userName + '&password=' + password;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },

            PlayAudio: function (isWord, audioFile) {
                var requestBod = 'Audio/GetAudio?IsWord=' + isWord + '&audioId=' + audioFile;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },

            GetConjuctionForms: function (word, languageTypeId, type) {
                var requestBod = 'ConjugationForms?Word=' + word + '&LanguageTypeId=' + languageTypeId + '&Type=' + type;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },

            GetConjuctionVerbForms: function (word, languageTypeId, type, subEntryId) {
                var requestBod = 'VerbForm?Word=' + word + '&LanguageTypeId=' + languageTypeId + '&Type=' + type + '&subentryId=' + subEntryId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },

            FetchEnglishSearchResult: function (keyword, isFirstFive, languageTypeId) {
                var requestBod = 'EnglishSearch?Keyword=' + keyword + '&FirstFive=' + isFirstFive + '&LanguageTypeId=' + languageTypeId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },
            FetchRootResult: function (keyword, languageTypeId) {
                var requestBod = 'ArabicRootSearch?rootkey=' + keyword + '&LanguageTypeId=' + languageTypeId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });

            },
            FetchRootKeyResult: function (keyword, languageTypeId) {
                var requestBod = 'RootKey?Keyword=' + keyword + '&LanguageTypeId=' + languageTypeId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },

            FetchArabicResult: function (keyword, languageTypeId) {
                var requestBod = 'ArabicWordSearch?word=' + keyword + '&LanguageTypeId=' + languageTypeId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });

            },

            FetchCategory: function (languageTypeId) {
                var requestBod = 'Category?LanguageTypeId=' + languageTypeId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });

            },

            FetchCategorySearchResult: function (categoryId, languageTypeId, type) {
                var requestBod;
                if (type == 'general') {
                    requestBod = 'CategorySearchResult?LanguageTypeId=' + languageTypeId + '&categoryId=' + categoryId;
                    return request.get(requestBod).then(function (result) {
                        return result.data;
                    });
                }
                else if (type == 'idioms') {

                    requestBod = 'Idioms?categoryId=' + categoryId;
                    return request.get(requestBod).then(function (result) {
                        return result.data;
                    });

                } else {
                    //tyep = 'index'
                    requestBod = 'IndexSearchResult?topicId=' + categoryId + '&LanguageTypeId=' + languageTypeId;
                    return request.get(requestBod).then(function (result) {
                        return result.data;
                    });
                }

            },

            FetchIdiomsAndSlang: function () {
                var requestBod = 'Idioms';
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });

            },

            FetchIndex: function (letterId, languageTypeId) {
                var requestBod = 'Index?LetterId=' + letterId + '&LanguageTypeId=' + languageTypeId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },

            FetchNewAdditions: function (languageTypeId) {
                var requestBod = 'NewAdditions?LanguageTypeId=' + languageTypeId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });

            },

            FetchArchiveFiles: function (userId) {
                var requestBod = 'ArchieveFile?UserId=' + userId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },

            DeleteArchiveFile : function (file) {
                var requestBod = 'ArchieveFile' ;
                return request.post(requestBod,file).then(function (result) {
                    return result.data;
                });
            },

            createArchiveFile : function (file) {
                var requestBod = 'ArchieveFile';
                return request.post(requestBod,file).then(function (result) {
                    return result.data;
                });
            },

            FetchArchiveWords: function (fileId) {
                var requestBod = 'ArchieveWord?FileId=' + fileId;
                return request.get(requestBod).then(function (result) {
                    return result.data;
                });
            },

            DeleteArchiveWord : function (word) {
                var requestBod = 'ArchieveWord';
                return request.post(requestBod,word).then(function (result) {
                    return result.data;
                });
            },

            AddWordToArchive: function (data) {
                console.log(data)
                var requestBod = 'ArchieveWord';
                return request.post(requestBod,data).then(function (result) {
                    return result.data;
                });
            },

            GetArchieveWordData: function (subentryId, english, arabic,userId) {
                var requestBod = '/ArchieveFile?UserId='+ userId;
                return request.get(requestBod).then(function (result) {
                    result.data.SubentryId = subentryId,
                    result.data.Arabic = arabic,
                    result.data.English = english;
                    return result.data;
                });
            },

        };
    });

})();