(function () {
    'use strict';
    var ar = angular.module('AR');
    ar.factory('request', function ($http, $rootScope, server, $ionicLoading, $timeout) {

        $http.defaults.transformRequest.push(function (data) {
            $rootScope.$broadcast('httpCallStarted');
            return data;
        });
        $http.defaults.transformResponse.push(function (data) {
            $rootScope.$broadcast('httpCallStopped');
            return data;
        });

        $rootScope.$on('httpCallStarted', function (e) {
            $ionicLoading.show({ template: '<div id="loading" class="spin-1"></div>' });
        });

        $rootScope.$on('httpCallStopped', function (e) {
            $ionicLoading.hide();
        });

        return {
            get: function (url, parameters) {
                var http = $http({
                    url: server.url + '/' + url,
                    method: "GET",
                    params: parameters
                }).success(function (xhr, status, headers, config) {
                    $rootScope.hasError = false;
                    $rootScope.eroor = "";
                }).error(function (xhr, status, headers, config) {
                    $rootScope.hasError = true;
                    $rootScope.error = "Connection Error, please try again!";
                });

                return http;
            },

            //del: function(url) {
            //    var http = $http({
            //        url: server.url + '/' + url,
            //        method: "DELETE",
            //        //data: {},
            //        //headers: {
            //        //    'Content-Type': 'application/x-www-form-urlencoded',
            //        //}
            //    });
            //    return http;
            //},

            post: function (url, data) {
                var http = $http({
                    url: server.url + '/' + url,
                    method: "POST",
                    transformRequest: function () {
                        var str = [];
                        for (var p in data)
                            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(data[p]));
                        return str.join("&");
                    },
                    data: {},
                    headers: {
                        'Content-Type': 'application/x-www-form-urlencoded',
                    }
                });

                return http;
            }
        };
    });
})();